
program GRAVITY4;{REAL THREE BODY PROBLEM-data pro Lagrangeovy libracni body}
uses graph,crt;
const h=0.0075;                {casovy diskretizacni parametr}
     {sm=0;   sx=0;    sy=173.205; svx=-1.73205; svy=0;}           {Slunce}
     {um=500; ux=-100; uy=0;       uvx=0;        uvy=-1;}          {Uran}
     {nm=500; nx=100;  ny=0;       nvx=0;        nvy=1;}           {Neptun}
      sm=1640; sx=0;  sy=0; svx=-2.3; svy=svx;           {Slunce}
      um=sm+100; ux=244; uy=-53; uvx=-svx/2;  uvy=uvx;          {Uran}
      nm=sm; nx=-ux;ny=-uy;  nvx=uvx;        nvy=uvx;           {Neptun}
{nm-hmota, nx,ny-pocatecni poloha, nvx,nvy-pocatecni rychlost}
      h2=h/2;h6=h/6;scale=1 {1.3456};sjj=320;sii=175;
      n=12;{pocet pohybovych rovnic}
type vector = array [1..n] of real;
label 1,2;
var i,graphdriver,graphmode: integer;
    a,fsux,fsuy,fsnx,fsny,funx,funy: real;
    z,y,k1,k2,k3,k4: vector;
function odm23(x: real): real;
    begin odm23:=x*sqrt(x) end;
function f(i: integer;y: vector): real;
begin case i of
    1:f:=y[2];
    2:f:=sm*fsux-nm*funx;
    3:f:=y[4];
    4:f:=sm*fsuy-nm*funy;
    5:f:=y[6];
    6:f:=sm*fsnx+um*funx;
    7:f:=y[8];
    8:f:=sm*fsny+um*funy;
    9:f:=y[10];
   10:f:=-um*fsux-nm*fsnx;
   11:f:=y[12];
   12:f:=-um*fsuy-nm*fsny end end;
procedure star(j,i,b: integer);
begin setcolor(b);circle(j,i,5);FloodFill(j,i,b) end;

begin y[1]:=ux;y[3]:=uy;y[2]:=uvx;y[4]:=uvy;
      y[5]:=nx;y[7]:=ny;y[6]:=nvx;y[8]:=nvy;
      y[9]:=sx;y[11]:=sy;y[10]:=svx;y[12]:=svy;
graphdriver:=detect;initgraph(graphdriver,graphmode,' ');
setgraphmode(graphmode);
1:star(sjj+round(y[1]),sii-round(y[3]/scale),12);
  star(sjj+round(y[5]),sii-round(y[7]/scale),9);
  star(sjj+round(y[9]),sii-round(y[11]/scale),14);
if keypressed then begin closegraph;goto 2 end;
{METODA RUNGOVA-KUTTOVA}
a:=odm23(sqr(y[9]-y[1])+sqr(y[11]-y[3]));
fsux:=(y[9]-y[1])/a;fsuy:=(y[11]-y[3])/a;
a:=odm23(sqr(y[9]-y[5])+sqr(y[11]-y[7]));
fsnx:=(y[9]-y[5])/a;fsny:=(y[11]-y[7])/a;
a:=odm23(sqr(y[1]-y[5])+sqr(y[3]-y[7]));
funx:=(y[1]-y[5])/a;funy:=(y[3]-y[7])/a;
for i:=1 to n do begin k1[i]:=f(i,y);z[i]:=y[i]+h2*k1[i] end;
for i:=1 to n do k2[i]:=f(i,z);
for i:=1 to n do z[i]:=y[i]+h2*k2[i];
for i:=1 to n do k3[i]:=f(i,z);
for i:=1 to n do z[i]:=y[i]+h*k3[i];
for i:=1 to n do k4[i]:=f(i,z);
for i:=1 to n do y[i]:=y[i]+h6*(k1[i]+2*k2[i]+2*k3[i]+k4[i]);
goto 1;2:end.